<?php
/*************************************************************************************/
/*         ### Report MAJ information trajet en voiture via Waze ###                 */
/*                                                                                   */
/*                     Développement par eedomusbox@gmail.com                        */
/*                            Version 1.2                                            */
/*************************************************************************************/

/******************** Récupération des données obligatoires **************************/


//************************************** Périphérique ********************************/
 if (isset($_GET["periph"])) 
	{ $periph = $_GET["periph"];}
 else 
	{ echo 'Aucun periphetique n est indiqué [&periph]';
	  exit;
	} 
	
//************************************** Ville de départ*****************************/	
 if (isset($_GET["depart"])) 
	{ $depart = $_GET["depart"];}
 else 
	{ echo 'Aucune coordonnée de départ indiquée [&depart]';
	  exit;
	} 
 
 if (isset($_GET["xpath"])) 
	{ $xpath = $_GET["xpath"];}
 else
	 {$xpath = 1;} 
	 
 if (isset($_GET["debug"])) { $debug = $_GET["debug"];}

	 	 
//************************************** Ville d'arrivée *****************************/
if (isset($_GET["arrive"])) 
	{ $arrive = $_GET["arrive"]; }
 else 
	{ echo 'Aucune coordonnée d arrivée indiquée [&arrive]'; 
	  exit;
	}    
	
//*************************************** Code API Périphérique ***********************/
//Découpage des coordonnées GPS	
$departexp  = explode("_",$depart);
$depart_x   = $departexp[0];
$depart_y   = $departexp[1];

$arriveexp  = explode("_",$arrive);
$arrive_x   = $arriveexp[0];
$arrive_y   = $arriveexp[1];


// Création de la requète : plusieurs options sont disponibles :
				// Format du fichier JSON &returnJSON=true ou XML &returnXML=true 
				// Nombre de trajet à récuperer &nPaths=2
				// Option &options=AVOID_TRAILS%3At%2CALLOW_UTURNS"
				// Géométrie &returnGeometries=true Attention ne fonction pas en Json
				// Instruction &returnInstructions=true
$query = 'https://www.waze.com/row-RoutingManager/routingRequest?from=x%3A'.$depart_x.'+y%3A'.$depart_y.'&to=x%3A'.$arrive_x.'+y%3A'.$arrive_y.'&returnJSON=true&timeout=60000&nPaths='.$xpath.'&options=AVOID_TRAILS%3At%2CALLOW_UTURNS';

//Appel de la requête et transformation
$jsonResponse      = httpQuery($query, 'GET', "");
if ($debug == 1) {echo '**debug**<br>Jsonresponse<br>**debug**<br>'; var_dump($jsonResponse);}
$routeResponseJson = sdk_json_decode($jsonResponse,true);
if ($debug == 1) {echo '<br>**debug**<br>routeResponseJson<br>**debug**<br>'; var_dump($routeResponseJson);}

if ($xpath == 2)
// Nom des Routes
{
	$route1Name = $routeResponseJson['alternatives'][0]['response']['routeName'];  
	$route2Name = $routeResponseJson['alternatives'][1]['response']['routeName'];

//Récupération des routes et calcul du temps total de trajet
	$route1 = $routeResponseJson['alternatives'][0]['response']['results'];
	$route2 = $routeResponseJson['alternatives'][1]['response']['results'];
}
else 
 {
	 $route1Name = $routeResponseJson['response']['routeName'];
	 $route1 = $routeResponseJson['response']['results'];
 }
 
 if ($debug == 1) {echo '<br>**debug**<br>route1Name<br>**debug**<br>'; var_dump($route1Name);}
 if ($debug == 1) {echo '**debug**<br>route2Name<br>**debug**<br>'; var_dump($route2Name);}
 if ($debug == 1) {echo '**debug**<br>route1<br>**debug**<br>'; var_dump($route1);}
 if ($debug == 1) {echo '**debug**<br>route2<br>**debug**<br>'; var_dump($route2);}
 
//Ces calculs sont en secondes
$route1TotalTimeSec = 0;
foreach ($route1 as $street){
	$route1TotalTimeSec += $street['crossTime'];
}

$route2TotalTimeSec = 0;
foreach ($route2 as $street){
	$route2TotalTimeSec += $street['crossTime'];
}

 if ($debug == 1) {echo '**debug**<br>$route1TotalTimeSec<br>**debug**<br>'; var_dump($route1TotalTimeSec);}
 if ($debug == 1) {echo '**debug**<br>$route2TotalTimeSec<br>**debug**<br>'; var_dump($route2TotalTimeSec);}
 
//Conversion en minutes 
$route1TotalTimeMin =  $route1TotalTimeSec/60%60 .','.$route1TotalTimeSec%60 .' mn';
$route2TotalTimeMin = $route2TotalTimeSec/60%60 .','.$route2TotalTimeSec%60 .' mn';

// Formatage du texte
$textChemin1 = $route1Name.':'.$route1TotalTimeMin;
$textChemin2 = $route2Name.':'.$route2TotalTimeMin;
if ($xpath == 2)
{$texteChemin = $textChemin1.' '.$textChemin2;}
else
{$texteChemin = $textChemin1;}

// Mise à jour du périphériques
$result = setValue($periph, $texteChemin );

 if (strpos($result, '"success":1') == false)
{
  echo "Une erreur est survenue lors de la mise à jour [".$result."]";
  exit;
}
 
// Affichage du résultat sous forme XML A titre d'information
sdk_header('text/xml');
echo "<root>";
echo "<Route>".$textChemin1."</Route>";
if ($xpath == 2)
{
echo "<Route>".$textChemin2."</Route>";
}
echo "</root>";

 ?>
